<script setup lang="ts">
    import { ServiceOffer } from '@/serviceOffer/entities/serviceOffer/ServiceOffer'
    import { defineProps, defineEmits, computed } from 'vue'

    const props = defineProps<{
        role: ServiceOffer['availableRoles'][0]
        selectedRoles: string[]
    }>()

    const emit = defineEmits<{
        (e: 'toggleRole', role: string): void
    }>()

    const selectedRole = computed(() =>
        props.selectedRoles.includes(props.role.value)
    )

    const toggleRole = () => {
        emit('toggleRole', props.role.value)
    }
</script>

<template>
    <v-list>
        <v-list-item
            :title="role.libelle"
            :subtitle="$vuetify.display.mdAndUp ? role.description : undefined"
            @click="toggleRole"
        >
            <template #prepend>
                <v-list-item-action start>
                    <v-checkbox-btn
                        :model-value="selectedRole"
                        data-cy="roles"
                    />
                </v-list-item-action>
            </template>
            <template v-if="$vuetify.display.smAndDown" #append>
                <v-tooltip :text="role.description" open-on-click>
                    <template #activator="{ props: activatorProps }">
                        <v-icon
                            v-bind="activatorProps"
                            icon="mdi-information-outline"
                            color="info"
                        />
                    </template>
                </v-tooltip>
            </template>
        </v-list-item>
    </v-list>
</template>
